/**
 * 
 */
package com.perfectech.cts;

import java.io.IOException;
import java.util.ArrayList;

import android.content.ContentValues;
import android.content.Context;
import android.util.Log;

/**
 * @author jcairns
 *
 */
public class DBParameters {

	public String readParameter(String sParamName, Context oContext, String sDBName, int iVersionVal) {
		String sRtnVal = "";
		ArrayList<ArrayList<String>> sStringList = null;
	    CTSDBHelper oDB = new CTSDBHelper(oContext,sDBName,null,iVersionVal);
		try {
			oDB.createDataBase();
			oDB.openDataBase();
			String sSQL = "select Value from Parameters where Name = '";
			sSQL += sParamName + "'";
			sStringList = oDB.selectRecordsFromDBList(sSQL, null);
		} catch (Exception ex) {
			DBLogs.insert("Database Exception: " + ex.toString(),
					"DBParameters.readParameters",
					oContext, sDBName, iVersionVal);
		} finally {
			oDB.close();
		}
		for (ArrayList<String> sValue : sStringList) {
			sRtnVal = sValue.get(0);
		}

		return sRtnVal;
	}
	
	public void updateParameter(String sParamName, String sParamValue, Context oContext, String sDBName, int iVersionVal) {
	   	CTSDBHelper oDB = new CTSDBHelper(oContext,sDBName,null,iVersionVal);
		try {
			oDB.createDataBase();
			oDB.openDataBase();
			ContentValues oValues = new ContentValues();
			oValues.put("Value", sParamValue);
			oDB.updateRecordsInDB("Parameters", "Name = '" + sParamName + "'", oValues);
		} catch (IOException ex) {
			DBLogs.insert("Database Exception: " + ex.toString(),
					"DBParameters.updateParameters",
					oContext, sDBName, iVersionVal);
		} finally {
			oDB.close();
		}
	}
	
	public void insertParameter(String sParamName, String sParamValue, Context oContext, String sDBName, int iVersionVal) {
		CTSDBHelper oDB = new CTSDBHelper(oContext,sDBName,null,iVersionVal);
		try {
			oDB.createDataBase();
			oDB.openDataBase();
			ContentValues oValues = new ContentValues();
			oValues.put("Name", sParamName);
			oValues.put("Value", sParamValue);
			oDB.insertRecordsInDB("Parameters", null, oValues);
		} catch (IOException ex) {
			DBLogs.insert("Database Exception: " + ex.toString(),
					"DBParameters.insertParameters",
					oContext, sDBName, iVersionVal);
		} finally {
			oDB.close();
		}
	}

	public void deleteParameter(String sParamName, Context oContext, String sDBName, int iVersionVal) {
    	CTSDBHelper oDB = new CTSDBHelper(oContext,sDBName,null,iVersionVal);
		try {
			oDB.createDataBase();
			oDB.openDataBase();
			String sWhereClause = "Name='" + sParamName + "' ";
			oDB.deleteRecordInDB("Parameters", sWhereClause);
		} catch (IOException ex) {
			DBLogs.insert("Database Exception: " + ex.toString(),
					"DBParameters.deleteParameters",
					oContext, sDBName, iVersionVal);
		} finally {
			oDB.close();
		}
		
	}
}
