package com.perfectech.cts.activities;

import android.app.Activity;
import android.content.Context;
import android.database.sqlite.SQLiteException;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;

import com.perfectech.cts.DBLogs;
import com.perfectech.cts.R;
import com.perfectech.cts.CTSDBHelper;
import com.perfectech.cts.objects.SpinnerObj;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Locale;

/**
 * Created by jnissley on 3/6/16.
 */
public class CreateJobPickupFragment extends Fragment {
    private static final String sDBName = "CTS.db";
    private static final int iVersionVal = 7;
    private static Context oContext;
    private static ArrayList<SpinnerObj> sSpinnerStateList;
    private static ArrayList<SpinnerObj> sSpinnerCountryList;
    private OnDataPass dataPasser;
    private static EditText etCreateJobPickupFrom; //Required
    private static EditText etCreateJobPickupAddress1; //Required
    private static EditText etCreateJobPickupAddress2;
    private static EditText etCreateJobPickupCity; //Required
    private static Spinner spPickupState; //Required
    private static EditText etCreateJobPickupPostalCode; //Required
    private static EditText etCreateJobPickupPhoneNumber;
    private static EditText etCreateJobPickupEmailAddress;
    private static Spinner spPickupCountry;

    public CreateJobPickupFragment() {
    }

    public CreateJobPickupFragment newInstance() {
        CreateJobPickupFragment fragment = new CreateJobPickupFragment();
        return fragment;
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.fragment_create_job_pickup, container, false);
        oContext = getActivity().getApplicationContext();
        etCreateJobPickupFrom = (EditText) rootView.findViewById(R.id.etCreateJobPickupFromtext);
        etCreateJobPickupAddress1 = (EditText) rootView.findViewById(R.id.etCreateJobPickupAddress1text);
        etCreateJobPickupAddress2 = (EditText) rootView.findViewById(R.id.etCreateJobPickupAddress2text);
        etCreateJobPickupCity = (EditText) rootView.findViewById(R.id.etCreateJobPickupCitytext);
        spPickupState = (Spinner) rootView.findViewById(R.id.spPickupState);
        etCreateJobPickupPostalCode = (EditText) rootView.findViewById(R.id.etCreateJobPickupPostalCodetext);
        etCreateJobPickupPhoneNumber = (EditText) rootView.findViewById(R.id.etCreateJobPickupPhoneNumbertext);
        etCreateJobPickupEmailAddress = (EditText) rootView.findViewById(R.id.etCreateJobPickupEmailAddresstext);
        spPickupCountry = (Spinner) rootView.findViewById(R.id.spPickupCountry);
        //Make sure the array lists are defined before we getspinnerdata
        sSpinnerStateList = new ArrayList<>();
        sSpinnerCountryList = new ArrayList<>();
        getSpinnerData(oContext);
        Spinner spPUState = spPickupState;
        ArrayAdapter<SpinnerObj> spinnerArrayAdapterState =
                new ArrayAdapter<>(this.getActivity(), R.layout.create_job_spinner_item, sSpinnerStateList);
        spinnerArrayAdapterState.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spPUState.setAdapter(spinnerArrayAdapterState);
        //Hide the keyboard when the stinner is touched
        spPUState.setOnTouchListener(spinnerOnTouch);

        Spinner spPUCountry = spPickupCountry;
        ArrayAdapter<SpinnerObj> spinnerArrayAdapterCountry =
                new ArrayAdapter<SpinnerObj>(this.getActivity(), R.layout.create_job_spinner_item, sSpinnerCountryList);
        spinnerArrayAdapterCountry.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spPUCountry.setAdapter(spinnerArrayAdapterCountry);
        //Hide the keyboard when the stinner is touched
        spPUCountry.setOnTouchListener(spinnerOnTouch);
        return rootView;
    }

    //Detect if the fragment is losing focus so we can send the fragment data to the parent activity
    @Override
    public void setUserVisibleHint(boolean isVisibleToUser) {
        super.setUserVisibleHint(isVisibleToUser);

        // Make sure that we are currently visible
        if (this.isVisible()) {
            // If we are becoming invisible, then...
            if (!isVisibleToUser) {
                //Hide the soft keyboard
                final InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
                imm.hideSoftInputFromWindow(getView().getWindowToken(), 0);
                //Send captured data to parent activity
                Bundle bData = createAndSave();
                dataPasser.onDataPass("Pickup", bData);
            }
        }
    }

    @Override
    public void onAttach(Activity a) {
        super.onAttach(a);
        try {
            dataPasser = (OnDataPass) a;
        } catch (ClassCastException ex) {
            throw new ClassCastException(a.toString()
                    + " must implement OnHeadlineSelectedListener");
        }
    }

    private View.OnTouchListener spinnerOnTouch = new View.OnTouchListener() {
        //Hide the keyboard when the spinner is touched
        @Override
        public boolean onTouch(View v, MotionEvent event) {
            //Hide the soft keyboard
            final InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(getView().getWindowToken(), 0);
            return false;
        }
    };

    public interface OnDataPass {
        public void onDataPass(String FragmentName, Bundle data);
    }


    private void getSpinnerData(Context oContext) {
        CTSDBHelper oDB = new CTSDBHelper(oContext, sDBName, null, iVersionVal);
        //Open a database connection and get all of the hashes
        try {
            String sLanguage = Locale.getDefault().getLanguage();
            String sSQLState = "";
            String sSqlCountry = "";
            //The first value in the select is what will be passed to the web service
            //The second value is what is displayed in the dropdown
            switch (sLanguage) {
                case "en":
                    sSQLState = "select abbreviation, Name_en from States order by Sort, Name_en";
                    sSqlCountry = "select Name_en, Name_en from Countries order by Sort, Name_en";
                    break;
                case "es":
                    sSQLState = "select abbreviation, Name_sp from States order by Sort, Name_sp";
                    sSqlCountry = "select Name_en, Name_sp from Countries order by Sort, Name_sp";
                    break;
                default:
                    sSQLState = "select abbreviation, Name_en from States order by Sort, Name_en";
                    sSqlCountry = "select Name_en, Name_en from Countries order by Sort, Name_en";
            }
            oDB.createDataBase();
            oDB.openDataBase();
            ArrayList<ArrayList<String>> tableArrayState = oDB.selectRecordsFromDBList(sSQLState, null);
            ArrayList<ArrayList<String>> tableArrayCountry = oDB.selectRecordsFromDBList(sSqlCountry, null);
            Integer iSize = tableArrayState.size();
            if (iSize > 0) {
                for (ArrayList<String> sTableValues : tableArrayState) {
                    String sId = sTableValues.get(0).toString();
                    String sDisplay = sTableValues.get(1).toString();
                    SpinnerObj oSpinnerState = new SpinnerObj(sId, sDisplay);
                    sSpinnerStateList.add(oSpinnerState);
                };
            }
            SpinnerObj oSpinnerState = new SpinnerObj("-1", oContext.getResources().getString(R.string.create_job_spinner_hint));
            sSpinnerStateList.add(0,oSpinnerState);
            iSize = tableArrayCountry.size();
            if (iSize > 0) {
                for (ArrayList<String> sTableValues : tableArrayCountry) {
                    String sId = sTableValues.get(0).toString();
                    String sDisplay = sTableValues.get(1).toString();
                    SpinnerObj oSpinnerCountry = new SpinnerObj(sId, sDisplay);
                    sSpinnerCountryList.add(oSpinnerCountry);
                };
            }
        } catch (IOException ioe) {
            throw new Error("Unable to create database");
        } catch (SQLiteException ex) {
            DBLogs.insert("Sqlite Error: " + ex.toString(),
                    "CreateJobMainFragment.getWeightType", oContext,
                    sDBName, iVersionVal);
        } finally {
            oDB.close();
        }
    }

    public Bundle createAndSave() {
        //Send captured data to parent activity
        Bundle bData = new Bundle();
        bData.putString("from", etCreateJobPickupFrom.getText().toString());
        bData.putString("address1", etCreateJobPickupAddress1.getText().toString());
        bData.putString("address2", etCreateJobPickupAddress2.getText().toString());
        bData.putString("city", etCreateJobPickupCity.getText().toString());
        SpinnerObj oSpinnerState = (SpinnerObj) spPickupState.getSelectedItem();
        bData.putString("state", oSpinnerState.getId());
        bData.putString("postalcode", etCreateJobPickupPostalCode.getText().toString());
        bData.putString("phonenumber", etCreateJobPickupPhoneNumber.getText().toString());
        bData.putString("emailaddress", etCreateJobPickupEmailAddress.getText().toString());
        SpinnerObj oSpinnerCountry = (SpinnerObj) spPickupCountry.getSelectedItem();
        bData.putString("country", oSpinnerCountry.getId());
        return bData;
    }
}
