package com.perfectech.cts.activities;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ImageButton;
import android.widget.TableLayout;
import android.widget.TableRow;

import com.perfectech.cts.DBLogs;
import com.perfectech.cts.R;
import com.perfectech.cts.CTSDBHelper;

import java.io.IOException;
import java.util.ArrayList;

public class DVIRSelectActivity extends AppCompatActivity implements View.OnClickListener {

    private static final String sDBName = "CTS.db";
    private static final int iVersionVal = 7;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_dvirselect);
        build_form();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_dvirselect, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }
        if (id == R.id.action_logout) {
            finish();
            Intent i = new Intent(getApplicationContext(), CTSActivity.class);
            startActivity(i);
            return true;
        }
        if (id == R.id.action_help) {
            Intent i = new Intent(getApplicationContext(), HelpActivity.class);
            i.putExtra("ScreenID", "DVIRSelectActivity");
            startActivity(i);
            return true;
        }
        if (id == R.id.action_about) {
            Intent i = new Intent(getApplicationContext(), AboutActivity.class);
            startActivity(i);
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    public void onClick(View v) {
        try {
            String sTest = v.getTag().toString();
            Integer iChecklistNumber = Integer.parseInt(sTest);
            Intent checkListIntent = new Intent(this, DVIREntryActivity.class);
            checkListIntent.putExtra("CheckListNumber", iChecklistNumber);
            startActivity(checkListIntent);
        } catch (Exception ex) {
            // todo
        }
    }

    private void build_form() {
        CTSDBHelper oDB = new CTSDBHelper(getApplicationContext(), sDBName,
                null, iVersionVal);
        try {
            oDB.createDataBase();
        } catch (IOException ioe) {
            DBLogs.insert("Error: " + ioe.toString(),
                    "DVIREntryActivity.build_form", getApplicationContext(),
                    sDBName, iVersionVal);
            throw new Error("Unable to create database");
        }

        /*
        Change to this query
        select DVIRFormImages.ImageName, DVIRForms.Title, DVIRForms.DVIRNo from DVIRFormImages,DVIRForms
        where DVIRFormImages.DVIRID = DVIRForms.DVIRNo and DVIRForms.Active = 1 and DVIRFormImages.ImageNumber = 1;
         */

        oDB.openDataBase();
        String sSQL = "select ImageName from DVIRFormImages where ImageNumber = 1";
        ArrayList<String> sButtonImageList = oDB.getList(
                sSQL, null);
        oDB.close();

        if (sButtonImageList.size() > 0) {
            for (int i = 0; i < sButtonImageList.size(); i++) {
                TableLayout tlSelectDVIR = (TableLayout) findViewById(R.id.tlSelectDVIR);
                TableRow trSelectItems = new TableRow(this);
                View v = LayoutInflater.from(this).inflate(R.layout.dvir_select_table_row, trSelectItems, false);
                String sPictureMinusExtension = sButtonImageList.get(i).substring(0, sButtonImageList.get(i).length() - 4);
                int resID = getResources().getIdentifier(sPictureMinusExtension, "mipmap", getPackageName());
                ImageButton btLeft = (ImageButton) v.findViewById(R.id.btLeftButton);
                //Add 1 to the tag because we start at zero.  The tag must be a string value
                btLeft.setTag(String.valueOf(i + 1));
                btLeft.setOnClickListener(this);
                btLeft.setImageResource(resID);

                //Need to test to make sure there is not an odd number
                if (sButtonImageList.size() > i + 1) {
                    i=++i;
                    ImageButton btRight = (ImageButton) v.findViewById(R.id.btRightButton);
                    btRight.setOnClickListener(this);
                    //Integer iImageRight = getButtonPictureID(++i);
                    sPictureMinusExtension = sButtonImageList.get(i).substring(0, sButtonImageList.get(i).length() - 4);
                    resID = getResources().getIdentifier(sPictureMinusExtension, "mipmap", getPackageName());
                    //Add 1 to the tag because we start at zero
                    btRight.setTag(String.valueOf(i + 1));
                    btRight.setImageResource(resID);
                } else {
                    ImageButton btRight = (ImageButton) v.findViewById(R.id.btRightButton);
                    btRight.setVisibility(btRight.INVISIBLE);
                }
                tlSelectDVIR.addView(v);
            }
        }
    }
}
