package com.perfectech.cts.activities;

import android.app.ActivityManager;
import android.app.Dialog;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.net.Uri;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TableRow;
import android.widget.TextView;
import android.content.DialogInterface;
import android.text.Html;
import android.text.method.LinkMovementMethod;
import android.graphics.Paint;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import android.app.AlertDialog;

import com.perfectech.cts.DBLogs;
import com.perfectech.cts.DateConvertClass;
import com.perfectech.cts.JobClass;
import com.perfectech.cts.JobStatusType;
import com.perfectech.cts.objects.Jobs;
import com.perfectech.cts.R;
import com.perfectech.cts.CTSDBHelper;
import com.perfectech.cts.syncClasses.JobTracking;
import com.perfectech.cts.syncClasses.SynJobTracking;
import com.perfectech.cts.syncClasses.SyncIntentService;
import com.perfectech.cts.syncClasses.SyncTasks;
import com.perfectech.cts.syncClasses.dataSyncService;
import com.perfectech.cts.webServices.SyncJson;

import org.json.JSONException;
import org.json.JSONObject;

public class JobsDetailActivity extends AppCompatActivity {

    private static final String sDBName = "CTS.db";
    private static final int iVersionVal = 7;
    private static String sAndroidID = "";
    private String sUserID = "";
    private String sJobID = "";
    private String sJobNum = "";
    private static ArrayList<ArrayList<String>> jobArray;
    private static ArrayList<ArrayList<String>> jobStatusTypeArray;
    private int iJobStatusID;
    private Jobs jobObj;
    private MenuItem miAccept;
    private MenuItem miDecline;
    private MenuItem miPause;
    private MenuItem miSignature;
    private MenuItem miContinue;
    private MenuItem miStart;
    private MenuItem miComplete;
    private Button btnPickupOrder;

    //final CharSequence[] sig_radio={getResources().getString(R.string.job_detail_pickup_sig1), getResources().getString(R.string.job_detail_delivery_sig1)};


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_jobs_detail);

        if (savedInstanceState == null) {
            sJobID = getIntent().getExtras().getString("JobID");
        } else {
            sJobID = savedInstanceState.getString("JobID", "None");
        }

        SharedPreferences prefs = getSharedPreferences("CTSSharedPrefs",
                Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = prefs.edit();
        String sLoggedInUserCompany = prefs.getString("LoggedInUserCompany", "No Value");
        sUserID = prefs.getString("UserID", "No Value");
        TextView otvUserName = (TextView) findViewById(R.id.tvUserName);
        otvUserName.setText(sLoggedInUserCompany.substring(0,sLoggedInUserCompany.indexOf('-')));

        String sCurrentVersion = prefs.getString("CTSVersion", "No Value");
        //TextView otvCopyright = (TextView) findViewById(R.id.tvCopyright);
        //String sVersionText = otvCopyright.getText().toString();
        // need to replace the %RELNUM% with the actual rel version
        //sVersionText = sVersionText.replace("RELNUM", sCurrentVersion);
        //otvCopyright.setText(sVersionText);

        Button btnMapPU = (Button) findViewById(R.id.btnBtnMapPU);
        btnMapPU.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                doMap();
            }
        });

        btnPickupOrder = (Button) findViewById(R.id.btnViewOrder);
        btnPickupOrder.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                ViewOrder();
            }
        });

        TextView otvPickupPhone = (TextView) findViewById(R.id.tvPUPHONE);
        otvPickupPhone.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                TextView otvPickupPhone = (TextView) findViewById(R.id.tvPUPHONE);
                dialPhone(otvPickupPhone.getText().toString().trim());
            }
        });

        TextView otvDeliveryPhone = (TextView) findViewById(R.id.tvDelPHONE);
        otvDeliveryPhone.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                TextView otvDeliveryPhone = (TextView) findViewById(R.id.tvDelPHONE);
                dialPhone(otvDeliveryPhone.getText().toString().trim());
            }
        });
        try {
            getJobInfoFromDB(sJobID);
        } catch (Exception ex) {
            DBLogs.insert("Exception: " + ex.toString(),
                    "JobsDetailActivity.onCreateOptionsMenu",
                    getApplicationContext(), sDBName, iVersionVal);
        }

    }

    @Override
    public void onResume()
    {
        super.onResume();
        getJobInfoFromDB(sJobID);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_jobs_detail, menu);
        miAccept = menu.findItem(R.id.action_accept_job);
        miDecline = menu.findItem(R.id.action_decline_job);
        miPause = menu.findItem(R.id.action_pause_job);
        miSignature = menu.findItem(R.id.action_signature);
        miContinue = menu.findItem(R.id.action_continue_job);
        miStart = menu.findItem(R.id.action_start);
        miComplete = menu.findItem(R.id.action_process);

        updateButtons(iJobStatusID);

        return true;
    }

    @Override
    protected void onSaveInstanceState (Bundle outState) {
        outState.putString("JobID", sJobID);;
        super.onSaveInstanceState(outState);
        //outState.putString(KEY_TEXT_VALUE, mTextView.getText());
    }

    @Override
    protected void onRestoreInstanceState(Bundle inState) {
        sJobID = inState.getString("JobID", "None");
        super.onRestoreInstanceState(inState);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_signature) {
            doSig();
            return true;
        }
        if (id == R.id.action_accept_job) {
            updateJobsData(1);
            return true;
        }
        if (id == R.id.action_decline_job) {
            TextView title = new TextView(this);
            title.setText(getResources().getString(R.string.job_detail_are_you_sure));
            title.setBackgroundColor(Color.RED);
            title.setPadding(10, 10, 10, 10);
            title.setGravity(Gravity.CENTER);
            title.setTextColor(Color.WHITE);
            title.setTextSize(20);
            new AlertDialog.Builder(this)
                    .setCustomTitle(title)
                    .setMessage(getResources().getString(R.string.job_detail_you_are_declining))
                    .setPositiveButton(getResources().getString(R.string.ok), new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int which) {
                            // Do nothing but close the dialog
                            updateJobsData(2);
                        }
                    })
                    .setNegativeButton(getResources().getString(R.string.cancelBtnText), null)
                    .show();
            return true;
        }
        if (id == R.id.action_start) {
            //When we start a job we will see if the person has paid for the service.
            if (isPaid()) {
                try {
                    updateJobsData(1);
                    //When starting a job we must clear all geofence data
                    SharedPreferences enteredFences = getApplicationContext().getSharedPreferences("geofenceInfo", Context.MODE_PRIVATE);
                    enteredFences.edit().clear().apply();
                    //Add active job
                    addJobToPref(jobObj.job_num);
                } catch (Exception e) {
                    Log.d("Error: startJobTrackingSvc()", e.toString());
                }
            }
            return true;
        }
        if (id == R.id.action_continue_job) {
            //When we continue a job we will make sure that the person has paid for the service.
            if (isPaid()) {
                try {
                    updateJobsData(1);
                    removegeoFenceData(jobObj.job_num);
                    addJobToPref(jobObj.job_num);
                } catch (Exception e) {
                    Log.d("Error: startJobTrackingSvc()", e.toString());
                }
            }
            return true;
        }
        if (id == R.id.action_process) {
            TextView title = new TextView(this);
            title.setText(getResources().getString(R.string.job_detail_are_you_sure));
            title.setBackgroundColor(Color.RED);
            title.setPadding(10, 10, 10, 10);
            title.setGravity(Gravity.CENTER);
            title.setTextColor(Color.WHITE);
            title.setTextSize(20);
            new AlertDialog.Builder(this)
                    .setCustomTitle(title)
                    .setMessage(getResources().getString(R.string.job_detail_you_are_closing))
                    .setPositiveButton(getResources().getString(R.string.ok), new DialogInterface.OnClickListener() {
                        
                        public void onClick(DialogInterface dialog, int which) {
                            updateJobsData(1);
                            removeJobFromPref(jobObj.job_num);
                        }
                    })
                    .setNegativeButton(getResources().getString(R.string.cancelBtnText), null)
                    .show();
            return true;
        }
        if (id == R.id.action_pause_job) {
            addJobToPref(jobObj.job_num);
            updateJobsData(2);
            return true;
        }
        if (id == R.id.action_comments) {
            openCommentDiag();
        }
        if (id == R.id.action_icon_meanings) {
            Intent i = new Intent(getApplicationContext(), HelpActivity.class);
            i.putExtra("ScreenID", "IconMeanings");
            startActivity(i);
            return true;
        }
        if (id == R.id.action_help) {
            Intent i = new Intent(getApplicationContext(), HelpActivity.class);
            i.putExtra("ScreenID", "JobsDetailActivity");
            startActivity(i);
            return true;
        }
        if (id == R.id.action_about) {
            Intent i = new Intent(getApplicationContext(), AboutActivity.class);
            startActivity(i);
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    /*****************************************************************************************/
    /* This method will get the select job information from the db */
    /*****************************************************************************************/
    private void getJobInfoFromDB(String sJobID) {
        DateConvertClass oDateConvertClass = new DateConvertClass();
        oDateConvertClass.oContext = getApplicationContext();
        CTSDBHelper oDB = new CTSDBHelper(getApplicationContext(), sDBName,
                null, iVersionVal);
        try {
            oDB.createDataBase();
            oDB.openDataBase();
            String sLanguage = Locale.getDefault().getLanguage();
            String sSQL = "";
            switch (sLanguage) {
                case "en":
                    sSQL = "select A.job_id, A.date_time, A.job_status_id, B.name_en, A.assigned_id, A.manifest_num";
                    sSQL += ", A.container_num, A.delivery_address_line1, A.delivery_address_line2, A.delivery_city";
                    sSQL += ", A.delivery_state, A.delivery_postal_code, A.pickup_address_line1, A.pickup_address_line2";
                    sSQL += ", A.pickup_city, A.pickup_state, A.pickup_postal_code, A.username, A.importer_id, A.importer_name";
                    sSQL += ", A.job_num, A.pickup_date_time, A.delivery_date_time, A.ref_note, A.entry_number";
                    sSQL += ", A.pickup_phone, A.pickup_email_address, A.delivery_phone, A.delivery_email_address";
                    sSQL += ", A.pickup_signature_name, A.delivery_signature_name, A.pickup_order_doc_name";
                    sSQL += " from jobs as A join job_status_type as B on A.job_status_id = B.id where A.job_id = " + sJobID;
                    break;
                case "es":
                    sSQL = "select A.job_id, A.date_time, A.job_status_id, B.name_sp, A.assigned_id, A.manifest_num";
                    sSQL += ", A.container_num, A.delivery_address_line1, A.delivery_address_line2, A.delivery_city";
                    sSQL += ", A.delivery_state, A.delivery_postal_code, A.pickup_address_line1, A.pickup_address_line2";
                    sSQL += ", A.pickup_city, A.pickup_state, A.pickup_postal_code, A.username, A.importer_id, A.importer_name";
                    sSQL += ", A.job_num, A.pickup_date_time, A.delivery_date_time, A.ref_note, A.entry_number";
                    sSQL += ", A.pickup_phone, A.pickup_email_address, A.delivery_phone, A.delivery_email_address";
                    sSQL += ", A.pickup_signature_name, A.delivery_signature_name, A.pickup_order_doc_name";
                    sSQL += " from jobs as A join job_status_type as B on A.job_status_id = B.id where A.job_id = " + sJobID;
                    break;
                default:
                    sSQL = "select A.job_id, A.date_time, A.job_status_id, B.name_en, A.assigned_id, A.manifest_num";
                    sSQL += ", A.container_num, A.delivery_address_line1, A.delivery_address_line2, A.delivery_city";
                    sSQL += ", A.delivery_state, A.delivery_postal_code, A.pickup_address_line1, A.pickup_address_line2";
                    sSQL += ", A.pickup_city, A.pickup_state, A.pickup_postal_code, A.username, A.importer_id, A.importer_name";
                    sSQL += ", A.job_num, A.pickup_date_time, A.delivery_date_time, A.ref_note, A.entry_number";
                    sSQL += ", A.pickup_phone, A.pickup_email_address, A.delivery_phone, A.delivery_email_address";
                    sSQL += ", A.pickup_signature_name, A.delivery_signature_name, A.pickup_order_doc_name";
                    sSQL += " from jobs as A join job_status_type as B on A.job_status_id = B.id where A.job_id = " + sJobID;
            }
            Log.d("sSQL", sSQL);
            jobArray = oDB.selectRecordsFromDBList(sSQL, null);
        } catch (IOException ioe) {
            throw new Error("Error opening database database");
        } finally {
            oDB.close();
        }

        ArrayList<Jobs> allJobs = new ArrayList<Jobs>();
        Integer iSize = jobArray.size();
        Log.d("iSize", iSize.toString());
        jobObj = new Jobs();
        if (iSize > 0) {
            for (ArrayList<String> sValue : jobArray) {
                jobObj.job_id = sValue.get(0);
                //Convert the GMT database time to local device time
                jobObj.date_time = oDateConvertClass.GMTToLocal(sValue.get(1));
                jobObj.job_status_id = sValue.get(2);
                jobObj.status_name = sValue.get(3);
                jobObj.assigned_id = sValue.get(4);
                jobObj.manifest_num = sValue.get(5);
                jobObj.container_num = sValue.get(6);
                jobObj.delivery_address_line1 = sValue.get(7);
                jobObj.delivery_address_line2 = sValue.get(8);
                jobObj.delivery_city = sValue.get(9);
                jobObj.delivery_state = sValue.get(10);
                jobObj.delivery_postal_code = sValue.get(11);
                jobObj.pickup_address_line1 = sValue.get(12);
                jobObj.pickup_address_line2 = sValue.get(13);
                jobObj.pickup_city = sValue.get(14);
                jobObj.pickup_state = sValue.get(15);
                jobObj.pickup_postal_code = sValue.get(16);
                jobObj.username = sValue.get(17);
                jobObj.importer_id = sValue.get(18);
                jobObj.importer_name = sValue.get(19);
                jobObj.job_num = sValue.get(20);
                jobObj.pickup_date_time = oDateConvertClass.GMTToLocal(sValue.get(21));
                jobObj.delivery_date_time = oDateConvertClass.GMTToLocal(sValue.get(22));
                jobObj.ref_note = sValue.get(23);
                jobObj.entry_number = sValue.get(24);
                jobObj.pickup_phone = sValue.get(25);
                jobObj.pickup_email_address = sValue.get(26);
                jobObj.delivery_phone = sValue.get(27);
                jobObj.delivery_email_address = sValue.get(28);
                jobObj.pickup_signature_name = sValue.get(29);
                jobObj.delivery_signature_name = sValue.get(30);
                jobObj.pickup_order_doc_name = sValue.get(31);

                allJobs.add(jobObj);
            }
        }

        // update the screen fields with the data from the DB
        TextView tvJobID = (TextView) findViewById(R.id.tvJobID);
        TextView tvManifest = (TextView) findViewById(R.id.tvJobManifest);
        TextView tvContainer = (TextView) findViewById(R.id.tvJobContainer);
        TextView tvImporter = (TextView) findViewById(R.id.tvImporterName);
        TextView tvPUAddr1 = (TextView) findViewById(R.id.tvPUAddr1);
        TextView tvPUAddr2 = (TextView) findViewById(R.id.tvPUAddr2);
        TextView tvPUCSZ = (TextView) findViewById(R.id.tvPUCSZ);
        TextView tvPUPHONE = (TextView) findViewById(R.id.tvPUPHONE);
        TextView tvPUEMAIL = (TextView) findViewById(R.id.tvPUEMAIL);
        TextView tvDelAddr1 = (TextView) findViewById(R.id.tvDelAddr1);
        TextView tvDelAddr2 = (TextView) findViewById(R.id.tvDelAddr2);
        TextView tvDELCSZ = (TextView) findViewById(R.id.tvDelCSZ);
        TextView tvDELPHONE = (TextView) findViewById(R.id.tvDelPHONE);
        TextView tvDELEMAIL = (TextView) findViewById(R.id.tvDelEMAIL);
        TextView tvJobStatus = (TextView) findViewById(R.id.tvJobStatus);
        TextView tvPickupTime = (TextView) findViewById((R.id.tvDataPickupDate));
        TextView tvDeliveryTime = (TextView) findViewById(R.id.tvDataDeliveryDate);
        TextView tvRefNote = (TextView) findViewById(R.id.tvRefNote);
        TextView tvJobJobEntry = (TextView) findViewById(R.id.tvJobJobEntry);
        TextView tvPickupSig = (TextView) findViewById(R.id.tvPickupSig);
        TextView tvDeliverySig = (TextView) findViewById(R.id.tvDeliverySig);
        TableRow trContainerNum = (TableRow) findViewById(R.id.trContainerNum);
        TableRow trManafestNum = (TableRow) findViewById(R.id.trManifestNum);
        TableRow trEntryNum = (TableRow) findViewById(R.id.trEntryNum);

        sJobNum = jobObj.job_num;
        tvJobID.setText(jobObj.job_num);
        if (jobObj.manifest_num.length() < 2) {
            trManafestNum.setVisibility(View.GONE);
        } else {
            tvManifest.setText(jobObj.manifest_num);
        }
        if (jobObj.container_num.length() < 2) {
            trContainerNum.setVisibility(View.GONE);
        } else {
            tvContainer.setText(jobObj.container_num);
        }
        tvImporter.setText(jobObj.importer_name);
        tvPickupTime.setText(jobObj.pickup_date_time);
        tvDeliveryTime.setText(jobObj.delivery_date_time);
        if (jobObj.pickup_address_line1.length() < 2) {
            tvPUAddr1.setVisibility(View.GONE);
        } else {
            tvPUAddr1.setText(jobObj.pickup_address_line1);
        }
        if (jobObj.pickup_address_line2.length() < 2) {
            tvPUAddr2.setVisibility(View.GONE);
        } else {
            tvPUAddr2.setText(jobObj.pickup_address_line2);
        }
        tvJobStatus.setText(jobObj.status_name);
        String sPUCSZ = jobObj.pickup_city + ", " + jobObj.pickup_state + " " + jobObj.pickup_postal_code;
        tvPUCSZ.setText(sPUCSZ);
        tvPUPHONE.setText(jobObj.pickup_phone);
        tvPUPHONE.setPaintFlags(Paint.UNDERLINE_TEXT_FLAG);
        tvPUEMAIL.setText(Html.fromHtml("<a href=\"mailto:" + jobObj.pickup_email_address +  " \">" + jobObj.pickup_email_address + "</a>"));
        tvPUEMAIL.setMovementMethod(LinkMovementMethod.getInstance());

        if (jobObj.delivery_address_line1.length() < 2) {
            tvDelAddr1.setVisibility(View.GONE);
        } else {
            tvDelAddr1.setText(jobObj.delivery_address_line1);
        }
        if (jobObj.delivery_address_line2.length() < 2) {
            tvDelAddr2.setVisibility(View.GONE);
        } else {
            tvDelAddr2.setText(jobObj.delivery_address_line2);
        }
        String sDelCSZ = jobObj.delivery_city + ", " + jobObj.delivery_state + " " + jobObj.delivery_postal_code;
        tvDELCSZ.setText(sDelCSZ);
        tvDELPHONE.setText(jobObj.delivery_phone);
        tvDELPHONE.setPaintFlags(Paint.UNDERLINE_TEXT_FLAG);
        tvDELEMAIL.setText(Html.fromHtml("<a href=\"mailto:" + jobObj.delivery_email_address + " \">" + jobObj.delivery_email_address + "</a>"));
        tvDELEMAIL.setMovementMethod(LinkMovementMethod.getInstance());
        if (jobObj.ref_note.equals("null")) {
            tvRefNote.setText(" ");
        } else {
            tvRefNote.setText(jobObj.ref_note);
        }
        if (jobObj.entry_number.length() < 2) {
            trEntryNum.setVisibility(View.GONE);
        } else {
            tvJobJobEntry.setText(jobObj.entry_number);
        }
        if (jobObj.pickup_signature_name.length() > 1) {
            tvPickupSig.setText(jobObj.pickup_signature_name);
        } else {
            tvPickupSig.setText(getResources().getString(R.string.job_detail_not_signed));
        }
        if (jobObj.delivery_signature_name.length() > 1) {
            tvDeliverySig.setText(jobObj.delivery_signature_name);
        } else {
            tvDeliverySig.setText(getResources().getString(R.string.job_detail_not_signed));
        }
        Integer iJobStatusID = Integer.valueOf(jobObj.job_status_id);
        this.iJobStatusID = iJobStatusID;
        Log.d("iJobStatusID: ", iJobStatusID.toString());

     }

    /*****************************************************************************************/
    /* This method will update the job data based on the selection made */
    /*****************************************************************************************/
    private void updateJobsData(int iButton) {
        CTSDBHelper oDB = new CTSDBHelper(getApplicationContext(), sDBName,
                null, iVersionVal);
        Boolean bDeleteJob = false;

        //Intent iSvc3 = new Intent(this, JobTracking.class);
        // lets update the job status based on the button that was clicked
        switch (this.iJobStatusID) {
            case 1:
                if (iButton == 2) {
                    this.iJobStatusID = 9;
                    bDeleteJob = true;
                } else {
                    this.iJobStatusID = 3;
                }
                break;
            case 3:
                this.iJobStatusID = 4;
                break;
            case 5:
                this.iJobStatusID = 4;
                break;
            case 4:
                if (iButton ==2) {
                    this.iJobStatusID = 5;
                } else {
                    this.iJobStatusID = 6;
                }
                break;
            case 8:
                if (iButton == 2) {
                    this.iJobStatusID = 9;
                    bDeleteJob = true;
                } else {
                    this.iJobStatusID = 3;
                }
        }

        String sJobStatusName = getJobStatsTypeName();

        // update the database
        jobObj.job_status_id = Integer.toString(this.iJobStatusID);
        jobObj.status_name = sJobStatusName;

        ContentValues oValues = new ContentValues();
        oValues.put("job_status_id", jobObj.job_status_id);
        oValues.put("status_name", jobObj.status_name);

        try {
            oDB.createDataBase();
            oDB.openDataBase();
            oDB.updateRecordsInDB("jobs", "job_id=" + sJobID, oValues);
        } catch (IOException ioe) {
            throw new Error("Unable to create database");
        } finally {
            oDB.close();
        }

        // need to refresh the status on the screen and update the button
        TextView tvJobStatus = (TextView) findViewById(R.id.tvJobStatus);
        tvJobStatus.setText(jobObj.status_name);

        updateButtons(iJobStatusID);

        updateJobStatus(jobObj.job_id,jobObj.job_status_id);

        if (bDeleteJob) {
            deleteJob(jobObj.job_id);
        }

    }

    private String getJobStatsTypeName() {
        String sRtnVal = "";

        CTSDBHelper oDB = new CTSDBHelper(getApplicationContext(), sDBName,
                null, iVersionVal);
        try {
            oDB.createDataBase();
            oDB.openDataBase();
            String sSQL = "Select * ";
            sSQL += "from job_status_type ";
            sSQL += "where id = " + iJobStatusID;
            Log.d("sSQL", sSQL);
            jobStatusTypeArray = oDB.selectRecordsFromDBList(sSQL, null);
        } catch (IOException ioe) {
            throw new Error("Unable to open database");
        } finally {
            oDB.close();
        }

        Integer iSize = jobStatusTypeArray.size();
        Log.d("iSize", iSize.toString());
        JobStatusType jobStatusTypeObj = new JobStatusType();
        if (iSize > 0) {
            for (ArrayList<String> sValue : jobStatusTypeArray) {
                jobStatusTypeObj.id = sValue.get(0);
                String sLanguage = Locale.getDefault().getLanguage();
                switch (sLanguage) {
                    case "en":
                        jobStatusTypeObj.name = sValue.get(2);
                        break;
                    case "es":
                        jobStatusTypeObj.name = sValue.get(3);
                        break;
                    default:
                        jobStatusTypeObj.name = sValue.get(2);
                        break;
                }
            }
        }

        sRtnVal = jobStatusTypeObj.name;

        return sRtnVal;
    }

    private void doMap() {
        // display the map
        Intent i = new Intent(getApplicationContext(),
                JobMapActivity.class);
        i.putExtra("JobID", sJobID);
        startActivity(i);
    }

    private void doSig() {

        final CharSequence[] items = {getResources().getString(R.string.job_detail_pickup_sig1),
                getResources().getString(R.string.job_detail_delivery_sig1),
                getResources().getString(R.string.job_detail_cancel)};

        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        builder.setTitle(getResources().getString(R.string.job_detail_sig_capture_type));
        builder.setSingleChoiceItems(items, -1,
                new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int item) {
                        switch (item) {
                            case 0:
                                // Your code when first option seletced
                                Intent i = new Intent(getApplicationContext(), SigCapture.class);
                                i.putExtra("InType", "PU");
                                i.putExtra("InJobNum", jobObj.job_num);
                                startActivity(i);
                                dialog.cancel();
                                break;
                            case 1:
                                // Your code when 2nd  option seletced
                                Intent i1 = new Intent(getApplicationContext(), SigCapture.class);
                                i1.putExtra("InType", "DEL");
                                i1.putExtra("InJobNum", jobObj.job_num);
                                startActivity(i1);
                                dialog.cancel();
                                break;
                            case 2:
                                dialog.cancel();
                                break;
                        }
                    }
                });
        AlertDialog alert = builder.create();
        alert.show();
    }

    private void deleteJob(String sJobID) {
        CTSDBHelper oDB = new CTSDBHelper(getApplicationContext(), sDBName,
                null, iVersionVal);
        try {
            oDB.createDataBase();
            oDB.openDataBase();
            oDB.deleteRecordInDB("jobs", "id=" + sJobID);
        } catch (IOException ioe) {
            throw new Error("Unable to open database");
        } finally {
            oDB.close();
        }

    }

    private void updateJobStatus(String sJobID, String sStatusID) {
        try {
            DateConvertClass oDateConvertClass = new DateConvertClass();
            oDateConvertClass.oContext = getApplicationContext();
            String sCurrentDateTime = oDateConvertClass.GMTTimestamp();

            JSONObject oJobStatus = new JSONObject();
            oJobStatus.put("userID", sUserID);
            oJobStatus.put("jobID", sJobID);
            oJobStatus.put("jobStatus", sStatusID);
            oJobStatus.put("dateTime", sCurrentDateTime);

            // Now set up the sync queue and try to send now
            SyncTasks syncTasks = new SyncTasks();
            syncTasks.oContext = getApplicationContext();
            syncTasks.sRecType = "JOBSTATUP";
            syncTasks.sRecID = oJobStatus.toString();
            syncTasks.sDateTime = sCurrentDateTime;
            syncTasks.sQueued = "1"; //Set as queued so sync service will not pick it up
            syncTasks.sDateTimeQueued = sCurrentDateTime;
            syncTasks.sCompleted = "0";
            syncTasks.sDateTimeCompleted = "";
            long lRecID = syncTasks.write();
            Intent JobStatusIntent = new Intent(getApplicationContext(), SyncIntentService.class);
            JobStatusIntent.putExtra("RecType", "JOBSTATUP");
            JobStatusIntent.putExtra("ID", Long.toString(lRecID));
            JobStatusIntent.putExtra("RecID", oJobStatus.toString());
            startService(JobStatusIntent);
        } catch (JSONException ex) {
            DBLogs.insert("JSON Error: " + ex.toString(),
                    "JobsDetailActivity.updateJobStatus", getApplicationContext(),
                    sDBName, iVersionVal);
        }
    }

    private void ViewOrder() {
        Intent i = new Intent(getApplicationContext(), PickupOrderActivity.class);
        i.putExtra("JobID", sJobNum);
        i.putExtra("JobDoc", jobObj.pickup_order_doc_name);
        startActivity(i);
    }

    private void updateButtons(Integer iJobStatusID) {
        Intent iSvc3 = new Intent(this, JobTracking.class);
        JobClass oJob = new JobClass();
        oJob.oContext = getApplicationContext();
        btnPickupOrder.setEnabled(false);
        btnPickupOrder.setBackgroundColor(getResources().getColor(R.color.TISPurpleDisabled));
        switch (iJobStatusID) {
            case 1:
                miAccept.setVisible(true);
                miDecline.setVisible(true);
                miSignature.setVisible(false);
                miContinue.setVisible(false);
                miPause.setVisible(false);
                miStart.setVisible(false);
                miComplete.setVisible(false);
                break;
            case 3:
                miAccept.setVisible(false);
                miDecline.setVisible(false);
                miSignature.setVisible(false);
                miContinue.setVisible(false);
                miPause.setVisible(false);
                miStart.setVisible(true);
                miComplete.setVisible(false);
                break;
            case 4:
                btnPickupOrder.setEnabled(true);
                btnPickupOrder.setBackgroundColor(getResources().getColor(R.color.TISPurple));
                miAccept.setVisible(false);
                miDecline.setVisible(false);
                miSignature.setVisible(true);
                miContinue.setVisible(false);
                miPause.setVisible(true);
                miStart.setVisible(false);
                miComplete.setVisible(true);
                //Make sure job tracking service is started
                try {
                    if (!isMyServiceRunning(JobTracking.class)) {
                        startService(iSvc3);
                    }
                } catch(Exception ex) {
                    DBLogs.insert("Service start exception: " + ex.toString(),
                            "JobsDetailActivity.updateButtons.case 4",
                            getApplicationContext(), sDBName, iVersionVal);
                }
                break;
            case 5:
                miAccept.setVisible(false);
                miDecline.setVisible(false);
                miSignature.setVisible(false);
                miContinue.setVisible(true);
                miPause.setVisible(false);
                miStart.setVisible(false);
                miComplete.setVisible(false);
                //Stop the job tracking service since we are pausing the job
                //But check to make sure that there is no other job running
                try {
                    if (!oJob.activeJob()) {
                        //We must send any remaining coords to the server
                        SynJobTracking.oContext = getApplicationContext();
                        SynJobTracking.sendJobCoords();
                        //We need to clear out the gps coords so the will not be there if we start again
                        SharedPreferences enteredFences = getApplicationContext().getSharedPreferences("geofenceInfo", Context.MODE_PRIVATE);
                        enteredFences.edit().clear().apply();
                        stopService(new Intent(this, JobTracking.class));
                    }
                } catch (Exception ex) {
                    DBLogs.insert("Service start exception: " + ex.toString(),
                            "JobsDetailActivity.updateButtons.case 5",
                            getApplicationContext(), sDBName, iVersionVal);
                }
                break;
            case 6:
                miAccept.setVisible(false);
                miDecline.setVisible(false);
                miSignature.setVisible(false);
                miContinue.setVisible(false);
                miPause.setVisible(false);
                miStart.setVisible(false);
                miComplete.setVisible(false);
                //Stop the job tracking service since we are pausing the job
                //But check to make sure that there is no other job running
                try {
                    if (!oJob.activeJob()) {
                        //We must send any remaining coords to the server
                        //Must do this in a thread because it interact with the network
                        new Thread(new Runnable() {
                            @Override
                            public void run() {
                                SynJobTracking.oContext = getApplicationContext();
                                SynJobTracking.sendJobCoords();
                                //We need to clear out the gps coords so they will not be there if we start again
                                SharedPreferences enteredFences = getApplicationContext().getSharedPreferences("geofenceInfo", Context.MODE_PRIVATE);
                                enteredFences.edit().clear().apply();
                            }
                        }).start();
                        stopService(new Intent(this, JobTracking.class));
                    }
                } catch(Exception ex) {
                    DBLogs.insert("Service start exception: " + ex.toString(),
                            "JobsDetailActivity.updateButtons.case 6",
                            getApplicationContext(), sDBName, iVersionVal);
                }
                break;
            case 8:
                miAccept.setVisible(true);
                miDecline.setVisible(true);
                miSignature.setVisible(false);
                miContinue.setVisible(false);
                miPause.setVisible(false);
                miStart.setVisible(false);
                miComplete.setVisible(false);
                break;
            case 9:
                miAccept.setVisible(false);
                miDecline.setVisible(false);
                miSignature.setVisible(false);
                miContinue.setVisible(false);
                miPause.setVisible(false);
                miStart.setVisible(false);
                miComplete.setVisible(false);
        }
    }

    private Boolean isPaid () {
        Boolean bRtnValue = true;
        try {
            SyncJson oIsPaid = new SyncJson();
            oIsPaid.oContext = getApplicationContext();
            oIsPaid.webserviceName = "isPaid.php";
            JSONObject oIsPaidObject = new JSONObject();
            oIsPaidObject.put("userName", sUserID);
            oIsPaid.sendString = oIsPaidObject.toString();
            // If returns false we need to put up a dialog box and send the user back to the login page
            if (oIsPaid.SyncData().equals("false")) {
                bRtnValue = false;
                CTSDBHelper oDB = new CTSDBHelper(getApplicationContext(), sDBName,
                        null, iVersionVal);
                try {
                    oDB.createDataBase();
                    oDB.openDataBase();
                    // Update Remember me
                    ContentValues oValues = new ContentValues();
                    oValues.put("Paid", "0");
                    oDB.updateRecordsInDB("EmployeeMaster", "UserID = '" + sUserID + "'", oValues);
                    oDB.close();
                    String sTitle = getResources().getString(R.string.job_detail_error_not_paid);
                    String sMessage = getResources().getString(R.string.job_detail_error_not_paid_message);
                    errorDialog(sTitle, sMessage);
                    //Intent iLogin = Intent
                } catch(Exception ex) {
                    DBLogs.insert("Error: " + ex.toString(),
                            "JobsDetailActivity.ispaid.database",
                            getApplicationContext(), sDBName, iVersionVal);
                } finally {
                    oDB.close();
                }
                DBLogs.insert("User " + sUserID + "is not a paid user",
                        "SyncJobs.UpdateJob", getApplicationContext(),
                        sDBName, iVersionVal);
            }
        }catch (JSONException ex) {
            DBLogs.insert("JSON Error: " + ex.toString(),
                    "SyncJobs.isPaid", getApplicationContext(),
                    sDBName, iVersionVal);
        }
        return bRtnValue;
    }

    private void openCommentDiag() {
        final Dialog dialog = new Dialog(JobsDetailActivity.this,
                R.style.FullHeightDialog);
        dialog.setContentView(R.layout.dialog_jobs_comments);
        final Spinner spChoices = (Spinner) dialog.findViewById(R.id.spJCselection);
        final EditText etNotes = (EditText) dialog.findViewById(R.id.etJobsComments);
        final List<String> arraySpinner = new ArrayList<String>();
        ArrayAdapter<String> adapter;
        arraySpinner.add(getResources().getString(R.string.job_detail_spinner_note));
        arraySpinner.add(getResources().getString(R.string.job_detail_spinner_decline));
        adapter = new ArrayAdapter<String>(getApplicationContext(),
                R.layout.setting_date_view,arraySpinner);
        adapter.setDropDownViewResource(R.layout.setting_date_spinner);
        spChoices.setAdapter(adapter);
        dialog.setCancelable(true);
        dialog.show();
        Button btnSend = (Button) dialog.findViewById(R.id.btJobsCommentsEnter);
        btnSend.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                try {
                    DateConvertClass oDateConvertClass = new DateConvertClass();
                    oDateConvertClass.oContext = getApplicationContext();
                    String sCurrentDateTime = oDateConvertClass.GMTTimestamp();

                    JSONObject oJobNote = new JSONObject();
                    oJobNote.put("jobID", jobObj.job_id);
                    oJobNote.put("jobNote", etNotes.getText().toString());
                    oJobNote.put("userID", sUserID);
                    oJobNote.put("noteType", spChoices.getSelectedItem().toString());
                    oJobNote.put("dateTime", sCurrentDateTime);

                    SyncTasks syncTasks = new SyncTasks();
                    syncTasks.oContext = getApplicationContext();
                    syncTasks.sRecType = "JOBNOTEUP";
                    syncTasks.sRecID = oJobNote.toString();
                    syncTasks.sDateTime = sCurrentDateTime;
                    syncTasks.sQueued = "1"; //Set as queued so sync service will not pick it up
                    syncTasks.sDateTimeQueued = sCurrentDateTime;
                    syncTasks.sCompleted = "0";
                    syncTasks.sDateTimeCompleted = "";
                    long lRecID = syncTasks.write();
                    Intent JobNoteIntent = new Intent(getApplicationContext(), SyncIntentService.class);
                    JobNoteIntent.putExtra("RecType", "JOBNOTEUP");
                    JobNoteIntent.putExtra("ID", Long.toString(lRecID));
                    JobNoteIntent.putExtra("RecID", oJobNote.toString());
                    if (spChoices.getSelectedItem().toString().equals(getResources().getString(R.string.job_detail_spinner_decline))) {
                        //Make sure to remove the job from the notify queue onec declined
                        removeJobFromPref(jobObj.job_num);
                        //Also mark the job as declined in the local database
                        CTSDBHelper oDB = new CTSDBHelper(getApplicationContext(), sDBName,
                                null, iVersionVal);
                        try {
                            oDB.createDataBase();
                            oDB.openDataBase();
                            ContentValues oValues = new ContentValues();
                            oValues.put("job_status_id", 9);
                            //oValues.put("status_name", "Declined");
                            oDB.updateRecordsInDB("jobs", "job_id=" + sJobID, oValues);
                        } catch (Exception ex) {
                            DBLogs.insert("Error: " + ex.toString(),
                                    "JobsDetailActivity.openComment.database",
                                    getApplicationContext(), sDBName, iVersionVal);
                        } finally {
                            oDB.close();
                        }
                        dialog.dismiss();
                        finish();
                    }
                    dialog.dismiss();
                    startService(JobNoteIntent);
                } catch (JSONException ex) {
                    //To Do
                }

            }
        });
        Button btnCancel = (Button) dialog.findViewById(R.id.btJobsCommentsCancel);
        btnCancel.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                dialog.dismiss();
                //markMessageRead(sMessageID);
            }
        });
    }

    //Add job to the prefrence queue that will keep track of how long a job is opened.
    private void addJobToPref(String sJobID) {
        SharedPreferences activeJobs = getApplicationContext().getSharedPreferences("activeJobs", Context.MODE_PRIVATE);
        String sJob = activeJobs.getString(sJobID, "no value");
        if (sJob.equals("no value")) {
            DateConvertClass oDateConvertClass = new DateConvertClass();
            oDateConvertClass.oContext = getApplicationContext();
            activeJobs.edit().putString(sJobID, oDateConvertClass.GMTTimestamp()).apply();
        }
    }

    //Remove job from the prefrence queue that will keep track of how long a job is opened.
    private void removeJobFromPref(String sJobID) {
        SharedPreferences findJob = getApplicationContext().getSharedPreferences("activeJobs", Context.MODE_PRIVATE);
        String sJob = findJob.getString(sJobID, "no value");
        if (!sJob.equals("no value")) {
            findJob.edit().remove(sJobID).apply();
        }
    }

    private void errorDialog(String sTitle, String sMessage) {
        TextView title = new TextView(this);
        title.setText(sTitle);
        title.setBackgroundColor(Color.RED);
        title.setPadding(10, 10, 10, 10);
        title.setGravity(Gravity.CENTER);
        title.setTextColor(Color.WHITE);
        title.setTextSize(20);
        new AlertDialog.Builder(this)
                .setCustomTitle(title)
                .setMessage(sMessage)
                .setPositiveButton(getResources().getString(R.string.ok), new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int which) {
                        // close dialog and exit the app
                        dialog.dismiss();
                        stopService(new Intent(getApplicationContext(), dataSyncService.class));
                        stopService(new Intent(getApplicationContext(), JobTracking.class));
                        finishAffinity();
                        Intent i = new Intent(getApplicationContext(), CTSActivity.class);
                        startActivity(i);
                        //System.exit(0);
                    }
                })
                .show();
    }

    private void dialPhone(String sPhoneNumber) {
        Intent callIntent = new Intent(Intent.ACTION_CALL);
        callIntent.setData(Uri.parse("tel:" + sPhoneNumber));
                //textView.getText().toString().trim()));
        startActivity(callIntent );
    }

    private boolean isMyServiceRunning(Class<?> serviceClass) {
        ActivityManager manager = (ActivityManager) getSystemService(Context.ACTIVITY_SERVICE);
        for (ActivityManager.RunningServiceInfo service : manager.getRunningServices(Integer.MAX_VALUE)) {
            if (serviceClass.getName().equals(service.service.getClassName())) {
                return true;
            }
        }
        return false;
    }

    private void removegeoFenceData (String sJobNumber) {
        SharedPreferences enteredFences = getApplicationContext().getSharedPreferences("geofenceInfo", Context.MODE_PRIVATE);
        Map<String, ?> keys = enteredFences.getAll();
        for(Map.Entry<String,?> entry : keys.entrySet()){
            if (entry.getKey().contains(sJobNumber)) {
                enteredFences.edit().remove(entry.getKey()).apply();
            }
            Log.d("map values",entry.getKey() + ": " +
                    entry.getValue().toString());
        }
    }
}
