package com.perfectech.cts.syncClasses;

import android.app.Activity;
import android.content.ContentValues;
import android.content.Context;
import android.util.Log;

import com.perfectech.cts.DBLogs;
import com.perfectech.cts.DBParameters;
import com.perfectech.cts.CTSDBHelper;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.util.ArrayList;

/**
 * Created by cairnsj on 6/14/15.
 */
public class SyncImporter {
    private static final int TIMEOUT_MILLISEC = 600;
    private static final String sDBName = "CTS.db";
    public static Activity inActivity;
    public static Context oContext;
    public static String sUserName;
    private static final int iVersionVal = 7;

    public static void getImporters() throws Exception {
        String data = "";

        // need to get the last message id that was last syncd from the server
        int iLastSyncMsgID = lastImporterIdSync();

        DBParameters oDBParameters = new DBParameters();

        // WebServer Request URL
        String serverURL = oDBParameters.readParameter(
                "REST_BASE_URL", oContext, sDBName,
                iVersionVal);

        serverURL += "importerSync.php";


        try {
            // Set Request parameter
            data += "&" + URLEncoder.encode("lastId", "UTF-8") + "=" + iLastSyncMsgID;
        } catch (UnsupportedEncodingException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

        /************ Make Post Call To Web Server ***********/
        BufferedReader reader = null;
        StringBuilder sb = new StringBuilder();

        // Send data
        try {

            // Defined URL  where to send data
            URL url = new URL(serverURL);

            // Send POST data request
            URLConnection conn = url.openConnection();
            conn.setDoOutput(true);
            OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream());
            wr.write(data);
            wr.flush();

            // Get the server response
            reader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String line = null;

            // Read Server Response
            while ((line = reader.readLine()) != null) {
                // Append server response in string
                sb.append(line + "");

            }
        } catch (Exception ex) {
            ex.printStackTrace();
            Log.e("SyncImporters Error:", ex.toString());
        } finally {
            try {
                reader.close();
            } catch (Exception ex) {
            }
        }

        // put the information into the database
        CTSDBHelper oDB = new CTSDBHelper(oContext, sDBName, null, iVersionVal);
        try {
            oDB.createDataBase();
            oDB.openDataBase();
            try {
                JSONArray oJsonArray = new JSONArray(sb.toString());

                for (int iCounter = 0; iCounter < oJsonArray.length(); iCounter++) {

                    JSONObject json = oJsonArray.getJSONObject(iCounter);
                    ContentValues oValues = new ContentValues();
                    oValues.put("id", json.getString("id"));
                    oValues.put("name", json.getString("name"));
                    oValues.put("address_line1", json.getString("address_line"));
                    oValues.put("address_line2", json.getString("address_line2"));
                    oValues.put("city", json.getString("city"));
                    oValues.put("state", json.getString("state"));
                    oValues.put("zipcode", json.getString("zip"));

                    try {
                        oDB.insertRecordsInDB("Importer", null, oValues);
                    } catch (Exception sqlEx) {
                        Log.e("sqlEx:", sqlEx.toString());
                    }
                }
            } catch (Throwable t) {
                Log.d("getImporters():", t.toString());
            }
        } catch (Exception ex ){
            DBLogs.insert("Database Exception " + ex.getMessage(),
                    "SyncImporter.getImporters",
                    oContext, sDBName, iVersionVal);
        } finally {
            oDB.close();
        }
    }

    private static int lastImporterIdSync() {
        int iRtnVal = 0;

        // put the information into the database
        CTSDBHelper oDB = new CTSDBHelper(oContext, sDBName, null, iVersionVal);
        try {
            oDB.createDataBase();
            oDB.openDataBase();
            String sSQL = "select max(id) from Importer";
            ArrayList<ArrayList<String>> sStringList = oDB.selectRecordsFromDBList(
                    sSQL, null);
            oDB.close();

            if (sStringList != null) {
                for (int i = 0; i < sStringList.size(); i++) {
                    int iSize = sStringList.size();
                    ArrayList<String> tempList = sStringList.get(i);
                    try {
                        iRtnVal = Integer.parseInt(tempList.get(0));
                    } catch (Exception ex) {
                        iRtnVal = 0;
                    }
                }
            } else {
                iRtnVal = 0;
            }
        } catch (Exception ex) {
            DBLogs.insert("Database Exception " + ex.getMessage(),
                    "SyncImporter.lastImorterIdSync",
                    oContext, sDBName, iVersionVal);
        }

        return iRtnVal;
    }

}
